diff -ur tboot-1.9.5.orig/tboot/20_linux_tboot tboot-1.9.5/tboot/20_linux_tboot
--- tboot-1.9.5.orig/tboot/20_linux_tboot	2016-12-21 06:29:15.000000000 +0800
+++ tboot-1.9.5/tboot/20_linux_tboot	2017-08-02 23:33:52.732748172 +0800
@@ -171,6 +171,15 @@
 EOF
 }
 
+machine=`uname -m`
+case "$machine" in
+    i?86) GENKERNEL_ARCH="x86" ;;
+    mips|mips64) GENKERNEL_ARCH="mips" ;;
+    mipsel|mips64el) GENKERNEL_ARCH="mipsel" ;;
+    arm*) GENKERNEL_ARCH="arm" ;;
+    *) GENKERNEL_ARCH="$machine" ;;
+esac
+
 linux_list=`for i in /boot/vmlinu[xz]-* /vmlinu[xz]-* ; do
     	basename=$(basename $i)
 	version=$(echo $basename | sed -e "s,^[^0-9]*-,,g")
@@ -217,7 +226,9 @@
 		 "initrd.img-${alt_version}" "initrd-${alt_version}.img" \
 		 "initrd-${alt_version}" "initramfs-${alt_version}.img" \
 		 "initramfs-genkernel-${version}" \
-		 "initramfs-genkernel-${alt_version}"; do
+		 "initramfs-genkernel-${alt_version}" \
+		 "initramfs-genkernel-${GENKERNEL_ARCH}-${version}" \
+		 "initramfs-genkernel-${GENKERNEL_ARCH}-${alt_version}"; do
 	    if test -e "${dirname}/${i}" ; then
 		initrd="$i"
 		break
diff -ur tboot-1.9.5.orig/tboot/20_linux_xen_tboot tboot-1.9.5/tboot/20_linux_xen_tboot
--- tboot-1.9.5.orig/tboot/20_linux_xen_tboot	2016-12-21 06:29:54.000000000 +0800
+++ tboot-1.9.5/tboot/20_linux_xen_tboot	2017-08-02 23:34:01.347685520 +0800
@@ -165,6 +165,15 @@
 EOF
 }
 
+machine=`uname -m`
+case "$machine" in
+    i?86) GENKERNEL_ARCH="x86" ;;
+    mips|mips64) GENKERNEL_ARCH="mips" ;;
+    mipsel|mips64el) GENKERNEL_ARCH="mipsel" ;;
+    arm*) GENKERNEL_ARCH="arm" ;;
+    *) GENKERNEL_ARCH="$machine" ;;
+esac
+
 linux_list=`for i in /boot/vmlinu[xz]-* /vmlinu[xz]-* /boot/kernel-*; do
     if grub_file_is_not_garbage "$i"; then
     	basename=$(basename $i)
@@ -232,7 +241,9 @@
                 "initrd-${version}" "initrd.img-${alt_version}" \
                 "initrd-${alt_version}.img" "initrd-${alt_version}" \
                 "initramfs-genkernel-${version}" \
-                "initramfs-genkernel-${alt_version}" ; do
+                "initramfs-genkernel-${alt_version}" \
+                "initramfs-genkernel-${GENKERNEL_ARCH}-${version}" \
+                "initramfs-genkernel-${GENKERNEL_ARCH}-${alt_version}"; do
                 if test -e "${dirname}/${i}" ; then
                     initrd="$i"
                     break
